<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.actmatching.activity_matching_word2vec &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.actmatching.activity_matching_word2vec</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.actmatching.activity_matching_word2vec</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">gensim.models</span> <span class="kn">import</span> <span class="n">KeyedVectors</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">gensim.downloader</span> <span class="k">as</span> <span class="nn">api</span>

<span class="n">path</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s2">&quot;word2vec-google-news-300&quot;</span><span class="p">,</span> <span class="n">return_path</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">word2vec_model_path</span> <span class="o">=</span> <span class="n">path</span>
<span class="n">word2vec_model</span> <span class="o">=</span> <span class="n">KeyedVectors</span><span class="o">.</span><span class="n">load_word2vec_format</span><span class="p">(</span><span class="n">word2vec_model_path</span><span class="p">,</span> <span class="n">binary</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">limit</span><span class="o">=</span><span class="mi">500000</span><span class="p">)</span>

<div class="viewcode-block" id="get_most_similar_activity_without_common_words"><a class="viewcode-back" href="../../../nl2declare.actmatching.html#nl2declare.actmatching.activity_matching_word2vec.get_most_similar_activity_without_common_words">[docs]</a><span class="k">def</span> <span class="nf">get_most_similar_activity_without_common_words</span><span class="p">(</span><span class="n">activity</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">activities</span><span class="p">:</span> <span class="nb">list</span><span class="p">[</span><span class="nb">str</span><span class="p">]):</span>
    <span class="n">similarities</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">for</span> <span class="n">act</span> <span class="ow">in</span> <span class="n">activities</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">have_common_word</span><span class="p">(</span><span class="n">activity</span><span class="p">,</span><span class="n">act</span><span class="p">):</span>
            <span class="c1">#remove common words in the strings</span>
            <span class="n">new_start_word</span><span class="p">,</span> <span class="n">new_second_word</span> <span class="o">=</span> <span class="n">remove_common_words</span><span class="p">(</span><span class="n">activity</span><span class="p">,</span><span class="n">act</span><span class="p">)</span>

            <span class="n">new_start_word_list</span> <span class="o">=</span> <span class="n">new_start_word</span><span class="o">.</span><span class="n">split</span><span class="p">()</span>
            <span class="n">new_second_word_list</span> <span class="o">=</span> <span class="n">new_second_word</span><span class="o">.</span><span class="n">split</span><span class="p">()</span>

            <span class="k">if</span> <span class="n">new_start_word</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span> <span class="ow">and</span> <span class="n">new_second_word</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span><span class="p">:</span>
                <span class="n">similarities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
            <span class="k">elif</span> <span class="n">new_start_word</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span> <span class="ow">or</span> <span class="n">new_second_word</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span><span class="p">:</span>
                <span class="n">similarities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="k">elif</span> <span class="nb">len</span><span class="p">(</span><span class="n">new_start_word_list</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span> <span class="ow">or</span> <span class="nb">len</span><span class="p">(</span><span class="n">new_second_word_list</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span> <span class="c1">#e.g. target label from log: creation of claim, match with create claim</span>
                <span class="n">similarities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1">#calculate similarity </span>
                <span class="n">similarity_value</span> <span class="o">=</span> <span class="n">word2vec_model</span><span class="o">.</span><span class="n">similarity</span><span class="p">(</span><span class="n">new_start_word</span><span class="p">,</span> <span class="n">new_second_word</span><span class="p">)</span>
                <span class="n">similarities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">similarity_value</span><span class="p">)</span>

        <span class="k">else</span><span class="p">:</span>
            <span class="n">similarities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">activities</span><span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">similarities</span><span class="p">)],</span> <span class="nb">max</span><span class="p">(</span><span class="n">similarities</span><span class="p">)</span></div>

<div class="viewcode-block" id="have_common_word"><a class="viewcode-back" href="../../../nl2declare.actmatching.html#nl2declare.actmatching.activity_matching_word2vec.have_common_word">[docs]</a><span class="k">def</span> <span class="nf">have_common_word</span><span class="p">(</span><span class="n">stringOne</span><span class="p">,</span> <span class="n">stringTwo</span><span class="p">):</span>
    <span class="n">wordsOne</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">stringOne</span><span class="o">.</span><span class="n">split</span><span class="p">())</span>
    <span class="n">wordsTwo</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">stringTwo</span><span class="o">.</span><span class="n">split</span><span class="p">())</span>
    <span class="n">common_words</span> <span class="o">=</span> <span class="n">wordsOne</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="n">wordsTwo</span><span class="p">)</span>

    <span class="c1"># Return True if there is at least one common word, else False</span>
    <span class="k">return</span> <span class="nb">bool</span><span class="p">(</span><span class="n">common_words</span><span class="p">)</span></div>


<div class="viewcode-block" id="remove_common_words"><a class="viewcode-back" href="../../../nl2declare.actmatching.html#nl2declare.actmatching.activity_matching_word2vec.remove_common_words">[docs]</a><span class="k">def</span> <span class="nf">remove_common_words</span><span class="p">(</span><span class="n">stringOne</span><span class="p">,</span> <span class="n">stringTwo</span><span class="p">):</span>
    <span class="n">wordsOne</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">stringOne</span><span class="o">.</span><span class="n">split</span><span class="p">())</span>
    <span class="n">wordsTwo</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">stringTwo</span><span class="o">.</span><span class="n">split</span><span class="p">())</span>
    <span class="n">common_words</span> <span class="o">=</span> <span class="n">wordsOne</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="n">wordsTwo</span><span class="p">)</span>

    <span class="c1"># If there are common words, remove them and return the strings</span>
    <span class="k">if</span> <span class="n">common_words</span><span class="p">:</span>
        <span class="n">new_string_one</span> <span class="o">=</span> <span class="s1">&#39; &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">word</span> <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">wordsOne</span> <span class="k">if</span> <span class="n">word</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">common_words</span><span class="p">)</span>
        <span class="n">new_string_two</span> <span class="o">=</span> <span class="s1">&#39; &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">word</span> <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">wordsTwo</span> <span class="k">if</span> <span class="n">word</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">common_words</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">new_string_one</span><span class="p">,</span> <span class="n">new_string_two</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span></div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>